using System.Text.Json.Serialization;
using Amazon.Lambda.Core;
using Amazon.Lambda.RuntimeSupport;
using Amazon.Lambda.Serialization.SystemTextJson;

bool delayNextInvocation = true;
Console.WriteLine("In init");

var handler = (string input, ILambdaContext context) =>
{
    if (delayNextInvocation)
        Task.Delay(2000).GetAwaiter().GetResult();
    delayNextInvocation = false;
    return input.ToUpper();
};

await LambdaBootstrapBuilder.Create(handler, new SourceGeneratorLambdaJsonSerializer<LambdaFunctionJsonSerializerContext>())
        .Build()
        .RunAsync();
        
[JsonSerializable(typeof(string))]
public partial class LambdaFunctionJsonSerializerContext : JsonSerializerContext { }